import 'dart:math';

abstract class Geometry {
  factory Geometry.point({required Point<int> coordinates}) = PointGeometry._;
  factory Geometry.lineString({required List<Point<int>> coordinates}) =
      LineStringGeometry._;
  factory Geometry.polygon({required List<List<Point<int>>> coordinates}) =
      PolygonGeometry._;

  const Geometry._();
}

/// Point Geometry.
class PointGeometry extends Geometry {
  const PointGeometry._({
    required this.coordinates,
  }) : super._();

  final Point<int> coordinates;
}

/// LineString Geometry.
class LineStringGeometry extends Geometry {
  const LineStringGeometry._({
    required this.coordinates,
  }) : super._();

  final List<Point<int>> coordinates;
}

/// Polygon Geometry.
class PolygonGeometry extends Geometry {
  const PolygonGeometry._({
    required this.coordinates,
  }) : super._();

  final List<List<Point<int>>> coordinates;
}
